```@meta
CurrentModule = JustSayIt
```

# High-level API reference

This is the official High-level API reference of `JustSayIt`. Note that it can also be queried interactively from the [Julia REPL] using the [help mode](https://docs.julialang.org/en/v1/stdlib/REPL/#Help-mode):
```julia-repl
julia> using JustSayIt
julia>?
help?> JustSayIt.API
```

## Submodule
```@docs
JustSayIt.API
```

## Macros
#### Index
* [`JustSayIt.API.@voiceargs`](@ref)

#### Documentation
```@docs
JustSayIt.API.@voiceargs
```

## Functions
#### Index
* [`JustSayIt.API.is_next`](@ref)
* [`JustSayIt.API.are_next`](@ref)
* [`JustSayIt.API.pause_recording`](@ref)
* [`JustSayIt.API.restart_recording`](@ref)

#### Documentation
```@docs
JustSayIt.API.is_next
JustSayIt.API.are_next
JustSayIt.API.pause_recording
JustSayIt.API.restart_recording
```

## Constants
#### Index
* [`JustSayIt.API.LANG`](@ref)
* [`JustSayIt.API.MODELNAME`](@ref)


#### Documentation
```@docs
JustSayIt.API.LANG
JustSayIt.API.MODELNAME
```
